/**
 * @file math.cpp
 * @brief General math function definitions.
 *
 * @author Eric Butler (edbutler)
 */

#include "math/math.hpp"

#include "math/vector.hpp"
#include <cmath>

namespace _462 {

void color_vector_to_array( const Vector4& color, unsigned char* arr )
{
    // clamp values
    Vector4 tmp = color;
    tmp.clamp_min( Vector4::Zero );
    tmp.clamp_max( Vector4::Ones );

    // convert to ints
    arr[0] = static_cast<unsigned char>( tmp.x * 0xff );
    arr[1] = static_cast<unsigned char>( tmp.y * 0xff );
    arr[2] = static_cast<unsigned char>( tmp.z * 0xff );
    arr[3] = static_cast<unsigned char>( tmp.w * 0xff );
}

Vector4 color_array_to_vector( const unsigned char* arr )
{
    static const real_t inv = 1.0 / 255.0;
    return Vector4( arr[0] * inv, arr[1] * inv, arr[2] * inv, arr[3] * inv );
}

} /* _462 */

