/**
 * @file p0.hpp
 * @brief Project 0 implementation.
 *
 * @author Your Name (andrewid)
 */

#ifndef _462_P0_HPP_
#define _462_P0_HPP_

namespace _462 {

class Camera;
class Model;

enum PolygonMode
{
    POLYMODE_POINT,
    POLYMODE_LINE,
    POLYMODE_FILL
};

/**
 * Preforms all of the opengl initialization.
 */
void prj_initialize( Camera* camera, Model* model );

/**
 * Performs any cleanup.
 */
void prj_destroy( Model* model );

/**
 * Renders the model using the given camera.
 */
void prj_render( const Camera* camera, Model* model );

/**
 * Sets the polygon rendering mode.
 */
void prj_set_polygon_mode( PolygonMode mode );

} /* _462 */

#endif /* _462_P0_HPP_ */

